#ifndef PROTOCOL_LINUX_DMABUF_UNSTABLE_V1_H
#define PROTOCOL_LINUX_DMABUF_UNSTABLE_V1_H

#include "symgen_types.h"
extern const struct wp_interface intf_wl_buffer;
extern const struct wp_interface intf_zwp_linux_buffer_params_v1;
extern const struct wp_interface intf_zwp_linux_dmabuf_v1;
void do_zwp_linux_dmabuf_v1_evt_modifier(struct context *ctx, uint32_t format, uint32_t modifier_hi, uint32_t modifier_lo);
void call_zwp_linux_dmabuf_v1_evt_modifier(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
#define ZWP_LINUX_BUFFER_PARAMS_V1_ERROR_ALREADY_USED 0
#define ZWP_LINUX_BUFFER_PARAMS_V1_ERROR_PLANE_IDX 1
#define ZWP_LINUX_BUFFER_PARAMS_V1_ERROR_PLANE_SET 2
#define ZWP_LINUX_BUFFER_PARAMS_V1_ERROR_INCOMPLETE 3
#define ZWP_LINUX_BUFFER_PARAMS_V1_ERROR_INVALID_FORMAT 4
#define ZWP_LINUX_BUFFER_PARAMS_V1_ERROR_INVALID_DIMENSIONS 5
#define ZWP_LINUX_BUFFER_PARAMS_V1_ERROR_OUT_OF_BOUNDS 6
#define ZWP_LINUX_BUFFER_PARAMS_V1_ERROR_INVALID_WL_BUFFER 7
void do_zwp_linux_buffer_params_v1_req_add(struct context *ctx, int fd, uint32_t plane_idx, uint32_t offset, uint32_t stride, uint32_t modifier_hi, uint32_t modifier_lo);
void call_zwp_linux_buffer_params_v1_req_add(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
#define ZWP_LINUX_BUFFER_PARAMS_V1_FLAGS_Y_INVERT 1
#define ZWP_LINUX_BUFFER_PARAMS_V1_FLAGS_INTERLACED 2
#define ZWP_LINUX_BUFFER_PARAMS_V1_FLAGS_BOTTOM_FIRST 4
void do_zwp_linux_buffer_params_v1_req_create(struct context *ctx, int32_t width, int32_t height, uint32_t format, uint32_t flags);
void call_zwp_linux_buffer_params_v1_req_create(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
void do_zwp_linux_buffer_params_v1_evt_created(struct context *ctx, struct wp_object *buffer);
void call_zwp_linux_buffer_params_v1_evt_created(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
void do_zwp_linux_buffer_params_v1_req_create_immed(struct context *ctx, struct wp_object *buffer_id, int32_t width, int32_t height, uint32_t format, uint32_t flags);
void call_zwp_linux_buffer_params_v1_req_create_immed(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);

#endif /* PROTOCOL_LINUX_DMABUF_UNSTABLE_V1_H */
