#include "symgen_types.h"
#include <stddef.h>
extern const struct wp_interface intf_wl_output;
extern const struct wp_interface intf_wl_surface;
extern const struct wp_interface intf_wp_presentation;
extern const struct wp_interface intf_wp_presentation_feedback;
void do_wp_presentation_req_feedback(struct context *ctx, struct wp_object *surface, struct wp_object *callback);
void call_wp_presentation_req_feedback(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt) {
	unsigned int i = 0;
	struct wp_object *arg0 = get_object(mt, payload[i++], &intf_wl_surface);
	struct wp_object *arg1 = get_object(mt, payload[i], &intf_wp_presentation_feedback);
	do_wp_presentation_req_feedback(ctx, arg0, arg1);
	(void)fds;
}
static const unsigned int noi_wp_presentation_req_feedback[] = {
	1
};
static const struct wp_interface *not_wp_presentation_req_feedback[] = {
	&intf_wp_presentation_feedback
};
void do_wp_presentation_evt_clock_id(struct context *ctx, uint32_t clk_id);
void call_wp_presentation_evt_clock_id(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt) {
	unsigned int i = 0;
	uint32_t arg0 = payload[i];
	do_wp_presentation_evt_clock_id(ctx, arg0);
	(void)mt;
	(void)fds;
}
static const struct msg_data reqs_wp_presentation[] = {
	{"destroy", 0, 0, NULL, NULL, 0, 0, NULL, NULL, true, NULL},
	{"feedback", 0, 2, NULL, NULL, 0, 1, noi_wp_presentation_req_feedback, not_wp_presentation_req_feedback, false, call_wp_presentation_req_feedback},
};
static const struct msg_data evts_wp_presentation[] = {
	{"clock_id", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, call_wp_presentation_evt_clock_id},
};
const struct wp_interface intf_wp_presentation = {
	"wp_presentation",
	{reqs_wp_presentation, evts_wp_presentation},
	{2, 1},
};
void do_wp_presentation_feedback_evt_presented(struct context *ctx, uint32_t tv_sec_hi, uint32_t tv_sec_lo, uint32_t tv_nsec, uint32_t refresh, uint32_t seq_hi, uint32_t seq_lo, uint32_t flags);
void call_wp_presentation_feedback_evt_presented(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt) {
	unsigned int i = 0;
	uint32_t arg0 = payload[i++];
	uint32_t arg1 = payload[i++];
	uint32_t arg2 = payload[i++];
	uint32_t arg3 = payload[i++];
	uint32_t arg4 = payload[i++];
	uint32_t arg5 = payload[i++];
	uint32_t arg6 = payload[i];
	do_wp_presentation_feedback_evt_presented(ctx, arg0, arg1, arg2, arg3, arg4, arg5, arg6);
	(void)mt;
	(void)fds;
}
static const struct msg_data evts_wp_presentation_feedback[] = {
	{"sync_output", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"presented", 0, 7, NULL, NULL, 0, 0, NULL, NULL, false, call_wp_presentation_feedback_evt_presented},
	{"discarded", 0, 0, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
};
const struct wp_interface intf_wp_presentation_feedback = {
	"wp_presentation_feedback",
	{NULL, evts_wp_presentation_feedback},
	{0, 3},
};
