#ifndef PROTOCOL_PRESENTATION_TIME_H
#define PROTOCOL_PRESENTATION_TIME_H

#include "symgen_types.h"
extern const struct wp_interface intf_wl_output;
extern const struct wp_interface intf_wl_surface;
extern const struct wp_interface intf_wp_presentation;
extern const struct wp_interface intf_wp_presentation_feedback;
#define WP_PRESENTATION_ERROR_INVALID_TIMESTAMP 0
#define WP_PRESENTATION_ERROR_INVALID_FLAG 1
void do_wp_presentation_req_feedback(struct context *ctx, struct wp_object *surface, struct wp_object *callback);
void call_wp_presentation_req_feedback(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
void do_wp_presentation_evt_clock_id(struct context *ctx, uint32_t clk_id);
void call_wp_presentation_evt_clock_id(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
#define WP_PRESENTATION_FEEDBACK_KIND_VSYNC 0x1
#define WP_PRESENTATION_FEEDBACK_KIND_HW_CLOCK 0x2
#define WP_PRESENTATION_FEEDBACK_KIND_HW_COMPLETION 0x4
#define WP_PRESENTATION_FEEDBACK_KIND_ZERO_COPY 0x8
void do_wp_presentation_feedback_evt_presented(struct context *ctx, uint32_t tv_sec_hi, uint32_t tv_sec_lo, uint32_t tv_nsec, uint32_t refresh, uint32_t seq_hi, uint32_t seq_lo, uint32_t flags);
void call_wp_presentation_feedback_evt_presented(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);

#endif /* PROTOCOL_PRESENTATION_TIME_H */
