#ifndef PROTOCOL_DRM_H
#define PROTOCOL_DRM_H

#include "symgen_types.h"
extern const struct wp_interface intf_wl_buffer;
extern const struct wp_interface intf_wl_drm;
#define WL_DRM_ERROR_AUTHENTICATE_FAIL 0
#define WL_DRM_ERROR_INVALID_FORMAT 1
#define WL_DRM_ERROR_INVALID_NAME 2
#define WL_DRM_FORMAT_C8 0x20203843
#define WL_DRM_FORMAT_RGB332 0x38424752
#define WL_DRM_FORMAT_BGR233 0x38524742
#define WL_DRM_FORMAT_XRGB4444 0x32315258
#define WL_DRM_FORMAT_XBGR4444 0x32314258
#define WL_DRM_FORMAT_RGBX4444 0x32315852
#define WL_DRM_FORMAT_BGRX4444 0x32315842
#define WL_DRM_FORMAT_ARGB4444 0x32315241
#define WL_DRM_FORMAT_ABGR4444 0x32314241
#define WL_DRM_FORMAT_RGBA4444 0x32314152
#define WL_DRM_FORMAT_BGRA4444 0x32314142
#define WL_DRM_FORMAT_XRGB1555 0x35315258
#define WL_DRM_FORMAT_XBGR1555 0x35314258
#define WL_DRM_FORMAT_RGBX5551 0x35315852
#define WL_DRM_FORMAT_BGRX5551 0x35315842
#define WL_DRM_FORMAT_ARGB1555 0x35315241
#define WL_DRM_FORMAT_ABGR1555 0x35314241
#define WL_DRM_FORMAT_RGBA5551 0x35314152
#define WL_DRM_FORMAT_BGRA5551 0x35314142
#define WL_DRM_FORMAT_RGB565 0x36314752
#define WL_DRM_FORMAT_BGR565 0x36314742
#define WL_DRM_FORMAT_RGB888 0x34324752
#define WL_DRM_FORMAT_BGR888 0x34324742
#define WL_DRM_FORMAT_XRGB8888 0x34325258
#define WL_DRM_FORMAT_XBGR8888 0x34324258
#define WL_DRM_FORMAT_RGBX8888 0x34325852
#define WL_DRM_FORMAT_BGRX8888 0x34325842
#define WL_DRM_FORMAT_ARGB8888 0x34325241
#define WL_DRM_FORMAT_ABGR8888 0x34324241
#define WL_DRM_FORMAT_RGBA8888 0x34324152
#define WL_DRM_FORMAT_BGRA8888 0x34324142
#define WL_DRM_FORMAT_XRGB2101010 0x30335258
#define WL_DRM_FORMAT_XBGR2101010 0x30334258
#define WL_DRM_FORMAT_RGBX1010102 0x30335852
#define WL_DRM_FORMAT_BGRX1010102 0x30335842
#define WL_DRM_FORMAT_ARGB2101010 0x30335241
#define WL_DRM_FORMAT_ABGR2101010 0x30334241
#define WL_DRM_FORMAT_RGBA1010102 0x30334152
#define WL_DRM_FORMAT_BGRA1010102 0x30334142
#define WL_DRM_FORMAT_YUYV 0x56595559
#define WL_DRM_FORMAT_YVYU 0x55595659
#define WL_DRM_FORMAT_UYVY 0x59565955
#define WL_DRM_FORMAT_VYUY 0x59555956
#define WL_DRM_FORMAT_AYUV 0x56555941
#define WL_DRM_FORMAT_XYUV8888 0x56555958
#define WL_DRM_FORMAT_NV12 0x3231564e
#define WL_DRM_FORMAT_NV21 0x3132564e
#define WL_DRM_FORMAT_NV16 0x3631564e
#define WL_DRM_FORMAT_NV61 0x3136564e
#define WL_DRM_FORMAT_YUV410 0x39565559
#define WL_DRM_FORMAT_YVU410 0x39555659
#define WL_DRM_FORMAT_YUV411 0x31315559
#define WL_DRM_FORMAT_YVU411 0x31315659
#define WL_DRM_FORMAT_YUV420 0x32315559
#define WL_DRM_FORMAT_YVU420 0x32315659
#define WL_DRM_FORMAT_YUV422 0x36315559
#define WL_DRM_FORMAT_YVU422 0x36315659
#define WL_DRM_FORMAT_YUV444 0x34325559
#define WL_DRM_FORMAT_YVU444 0x34325659
void do_wl_drm_evt_device(struct context *ctx, const char *name);
void call_wl_drm_evt_device(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
#define WL_DRM_CAPABILITY_PRIME 1
void do_wl_drm_req_create_prime_buffer(struct context *ctx, struct wp_object *id, int name, int32_t width, int32_t height, uint32_t format, int32_t offset0, int32_t stride0, int32_t offset1, int32_t stride1, int32_t offset2, int32_t stride2);
void call_wl_drm_req_create_prime_buffer(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);

#endif /* PROTOCOL_DRM_H */
