#include "symgen_types.h"
#include <stddef.h>
extern const struct wp_interface intf_wl_buffer;
extern const struct wp_interface intf_wl_callback;
extern const struct wp_interface intf_wl_compositor;
extern const struct wp_interface intf_wl_data_device;
extern const struct wp_interface intf_wl_data_device_manager;
extern const struct wp_interface intf_wl_data_offer;
extern const struct wp_interface intf_wl_data_source;
extern const struct wp_interface intf_wl_display;
extern const struct wp_interface intf_wl_keyboard;
extern const struct wp_interface intf_wl_output;
extern const struct wp_interface intf_wl_pointer;
extern const struct wp_interface intf_wl_region;
extern const struct wp_interface intf_wl_registry;
extern const struct wp_interface intf_wl_seat;
extern const struct wp_interface intf_wl_shell;
extern const struct wp_interface intf_wl_shell_surface;
extern const struct wp_interface intf_wl_shm;
extern const struct wp_interface intf_wl_shm_pool;
extern const struct wp_interface intf_wl_subcompositor;
extern const struct wp_interface intf_wl_subsurface;
extern const struct wp_interface intf_wl_surface;
extern const struct wp_interface intf_wl_touch;
void do_wl_display_req_sync(struct context *ctx, struct wp_object *callback);
void call_wl_display_req_sync(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt) {
	unsigned int i = 0;
	struct wp_object *arg0 = get_object(mt, payload[i], &intf_wl_callback);
	do_wl_display_req_sync(ctx, arg0);
	(void)fds;
}
static const unsigned int noi_wl_display_req_sync[] = {
	0
};
static const struct wp_interface *not_wl_display_req_sync[] = {
	&intf_wl_callback
};
void do_wl_display_req_get_registry(struct context *ctx, struct wp_object *registry);
void call_wl_display_req_get_registry(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt) {
	unsigned int i = 0;
	struct wp_object *arg0 = get_object(mt, payload[i], &intf_wl_registry);
	do_wl_display_req_get_registry(ctx, arg0);
	(void)fds;
}
static const unsigned int noi_wl_display_req_get_registry[] = {
	0
};
static const struct wp_interface *not_wl_display_req_get_registry[] = {
	&intf_wl_registry
};
void do_wl_display_evt_error(struct context *ctx, struct wp_object *object_id, uint32_t code, const char *message);
void call_wl_display_evt_error(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt) {
	unsigned int i = 0;
	struct wp_object *arg0 = get_object(mt, payload[i++], NULL);
	uint32_t arg1 = payload[i++];
	const char *arg2 = (const char *)&payload[i + 1];
	if (!payload[i]) arg2 = NULL;
	do_wl_display_evt_error(ctx, arg0, arg1, arg2);
	(void)fds;
}
static const bool sis_wl_display_evt_error[] = {
	true
};
static const unsigned int gap_wl_display_evt_error[] = {
	0
};
void do_wl_display_evt_delete_id(struct context *ctx, uint32_t id);
void call_wl_display_evt_delete_id(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt) {
	unsigned int i = 0;
	uint32_t arg0 = payload[i];
	do_wl_display_evt_delete_id(ctx, arg0);
	(void)mt;
	(void)fds;
}
static const struct msg_data reqs_wl_display[] = {
	{"sync", 0, 1, NULL, NULL, 0, 1, noi_wl_display_req_sync, not_wl_display_req_sync, false, call_wl_display_req_sync},
	{"get_registry", 0, 1, NULL, NULL, 0, 1, noi_wl_display_req_get_registry, not_wl_display_req_get_registry, false, call_wl_display_req_get_registry},
};
static const struct msg_data evts_wl_display[] = {
	{"error", 1, 3, gap_wl_display_evt_error, sis_wl_display_evt_error, 0, 0, NULL, NULL, false, call_wl_display_evt_error},
	{"delete_id", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, call_wl_display_evt_delete_id},
};
const struct wp_interface intf_wl_display = {
	"wl_display",
	{reqs_wl_display, evts_wl_display},
	{2, 2},
};
void do_wl_registry_req_bind(struct context *ctx, uint32_t name, const char *interface, uint32_t version, struct wp_object *id);
void call_wl_registry_req_bind(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt) {
	unsigned int i = 0;
	uint32_t arg0 = payload[i++];
	const char *arg1 = (const char *)&payload[i + 1];
	if (!payload[i]) arg1 = NULL;
	i += 1 + ((payload[i] + 0x3) >> 2);
	uint32_t arg2 = payload[i++];
	struct wp_object *arg3 = get_object(mt, payload[i], NULL);
	do_wl_registry_req_bind(ctx, arg0, arg1, arg2, arg3);
	(void)fds;
}
static const bool sis_wl_registry_req_bind[] = {
	true
};
static const unsigned int gap_wl_registry_req_bind[] = {
	2
};
static const unsigned int noi_wl_registry_req_bind[] = {
	(unsigned int)-1, 1
};
static const struct wp_interface *not_wl_registry_req_bind[] = {
	NULL, NULL
};
void do_wl_registry_evt_global(struct context *ctx, uint32_t name, const char *interface, uint32_t version);
void call_wl_registry_evt_global(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt) {
	unsigned int i = 0;
	uint32_t arg0 = payload[i++];
	const char *arg1 = (const char *)&payload[i + 1];
	if (!payload[i]) arg1 = NULL;
	i += 1 + ((payload[i] + 0x3) >> 2);
	uint32_t arg2 = payload[i];
	do_wl_registry_evt_global(ctx, arg0, arg1, arg2);
	(void)mt;
	(void)fds;
}
static const bool sis_wl_registry_evt_global[] = {
	true
};
static const unsigned int gap_wl_registry_evt_global[] = {
	1
};
void do_wl_registry_evt_global_remove(struct context *ctx, uint32_t name);
void call_wl_registry_evt_global_remove(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt) {
	unsigned int i = 0;
	uint32_t arg0 = payload[i];
	do_wl_registry_evt_global_remove(ctx, arg0);
	(void)mt;
	(void)fds;
}
static const struct msg_data reqs_wl_registry[] = {
	{"bind", 1, 2, gap_wl_registry_req_bind, sis_wl_registry_req_bind, 0, 2, noi_wl_registry_req_bind, not_wl_registry_req_bind, false, call_wl_registry_req_bind},
};
static const struct msg_data evts_wl_registry[] = {
	{"global", 1, 2, gap_wl_registry_evt_global, sis_wl_registry_evt_global, 0, 0, NULL, NULL, false, call_wl_registry_evt_global},
	{"global_remove", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, call_wl_registry_evt_global_remove},
};
const struct wp_interface intf_wl_registry = {
	"wl_registry",
	{reqs_wl_registry, evts_wl_registry},
	{1, 2},
};
static const struct msg_data evts_wl_callback[] = {
	{"done", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
};
const struct wp_interface intf_wl_callback = {
	"wl_callback",
	{NULL, evts_wl_callback},
	{0, 1},
};
static const unsigned int noi_wl_compositor_req_create_surface[] = {
	0
};
static const struct wp_interface *not_wl_compositor_req_create_surface[] = {
	&intf_wl_surface
};
static const unsigned int noi_wl_compositor_req_create_region[] = {
	0
};
static const struct wp_interface *not_wl_compositor_req_create_region[] = {
	&intf_wl_region
};
static const struct msg_data reqs_wl_compositor[] = {
	{"create_surface", 0, 1, NULL, NULL, 0, 1, noi_wl_compositor_req_create_surface, not_wl_compositor_req_create_surface, false, NULL},
	{"create_region", 0, 1, NULL, NULL, 0, 1, noi_wl_compositor_req_create_region, not_wl_compositor_req_create_region, false, NULL},
};
const struct wp_interface intf_wl_compositor = {
	"wl_compositor",
	{reqs_wl_compositor, NULL},
	{2, 0},
};
void do_wl_shm_pool_req_create_buffer(struct context *ctx, struct wp_object *id, int32_t offset, int32_t width, int32_t height, int32_t stride, uint32_t format);
void call_wl_shm_pool_req_create_buffer(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt) {
	unsigned int i = 0;
	struct wp_object *arg0 = get_object(mt, payload[i++], &intf_wl_buffer);
	int32_t arg1 = (int32_t)payload[i++];
	int32_t arg2 = (int32_t)payload[i++];
	int32_t arg3 = (int32_t)payload[i++];
	int32_t arg4 = (int32_t)payload[i++];
	uint32_t arg5 = payload[i];
	do_wl_shm_pool_req_create_buffer(ctx, arg0, arg1, arg2, arg3, arg4, arg5);
	(void)fds;
}
static const unsigned int noi_wl_shm_pool_req_create_buffer[] = {
	0
};
static const struct wp_interface *not_wl_shm_pool_req_create_buffer[] = {
	&intf_wl_buffer
};
void do_wl_shm_pool_req_resize(struct context *ctx, int32_t size);
void call_wl_shm_pool_req_resize(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt) {
	unsigned int i = 0;
	int32_t arg0 = (int32_t)payload[i];
	do_wl_shm_pool_req_resize(ctx, arg0);
	(void)mt;
	(void)fds;
}
static const struct msg_data reqs_wl_shm_pool[] = {
	{"create_buffer", 0, 6, NULL, NULL, 0, 1, noi_wl_shm_pool_req_create_buffer, not_wl_shm_pool_req_create_buffer, false, call_wl_shm_pool_req_create_buffer},
	{"destroy", 0, 0, NULL, NULL, 0, 0, NULL, NULL, true, NULL},
	{"resize", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, call_wl_shm_pool_req_resize},
};
const struct wp_interface intf_wl_shm_pool = {
	"wl_shm_pool",
	{reqs_wl_shm_pool, NULL},
	{3, 0},
};
void do_wl_shm_req_create_pool(struct context *ctx, struct wp_object *id, int fd, int32_t size);
void call_wl_shm_req_create_pool(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt) {
	unsigned int i = 0;
	unsigned int k = 0;
	struct wp_object *arg0 = get_object(mt, payload[i++], &intf_wl_shm_pool);
	int arg1 = fds[k];
	int32_t arg2 = (int32_t)payload[i];
	do_wl_shm_req_create_pool(ctx, arg0, arg1, arg2);
}
static const unsigned int noi_wl_shm_req_create_pool[] = {
	0
};
static const struct wp_interface *not_wl_shm_req_create_pool[] = {
	&intf_wl_shm_pool
};
static const struct msg_data reqs_wl_shm[] = {
	{"create_pool", 0, 2, NULL, NULL, 1, 1, noi_wl_shm_req_create_pool, not_wl_shm_req_create_pool, false, call_wl_shm_req_create_pool},
};
static const struct msg_data evts_wl_shm[] = {
	{"format", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
};
const struct wp_interface intf_wl_shm = {
	"wl_shm",
	{reqs_wl_shm, evts_wl_shm},
	{1, 1},
};
void do_wl_buffer_evt_release(struct context *ctx);
void call_wl_buffer_evt_release(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt) {
	do_wl_buffer_evt_release(ctx);
	(void)mt;
	(void)fds;
	(void)payload;
}
static const struct msg_data reqs_wl_buffer[] = {
	{"destroy", 0, 0, NULL, NULL, 0, 0, NULL, NULL, true, NULL},
};
static const struct msg_data evts_wl_buffer[] = {
	{"release", 0, 0, NULL, NULL, 0, 0, NULL, NULL, false, call_wl_buffer_evt_release},
};
const struct wp_interface intf_wl_buffer = {
	"wl_buffer",
	{reqs_wl_buffer, evts_wl_buffer},
	{1, 1},
};
static const bool sis_wl_data_offer_req_accept[] = {
	true
};
static const unsigned int gap_wl_data_offer_req_accept[] = {
	0
};
void do_wl_data_offer_req_receive(struct context *ctx, const char *mime_type, int fd);
void call_wl_data_offer_req_receive(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt) {
	unsigned int i = 0;
	unsigned int k = 0;
	const char *arg0 = (const char *)&payload[i + 1];
	if (!payload[i]) arg0 = NULL;
	int arg1 = fds[k];
	do_wl_data_offer_req_receive(ctx, arg0, arg1);
	(void)mt;
}
static const bool sis_wl_data_offer_req_receive[] = {
	true
};
static const unsigned int gap_wl_data_offer_req_receive[] = {
	0
};
static const bool sis_wl_data_offer_evt_offer[] = {
	true
};
static const unsigned int gap_wl_data_offer_evt_offer[] = {
	0
};
static const struct msg_data reqs_wl_data_offer[] = {
	{"accept", 1, 2, gap_wl_data_offer_req_accept, sis_wl_data_offer_req_accept, 0, 0, NULL, NULL, false, NULL},
	{"receive", 1, 1, gap_wl_data_offer_req_receive, sis_wl_data_offer_req_receive, 1, 0, NULL, NULL, false, call_wl_data_offer_req_receive},
	{"destroy", 0, 0, NULL, NULL, 0, 0, NULL, NULL, true, NULL},
	{"finish", 0, 0, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"set_actions", 0, 2, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
};
static const struct msg_data evts_wl_data_offer[] = {
	{"offer", 1, 1, gap_wl_data_offer_evt_offer, sis_wl_data_offer_evt_offer, 0, 0, NULL, NULL, false, NULL},
	{"source_actions", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"action", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
};
const struct wp_interface intf_wl_data_offer = {
	"wl_data_offer",
	{reqs_wl_data_offer, evts_wl_data_offer},
	{5, 3},
};
static const bool sis_wl_data_source_req_offer[] = {
	true
};
static const unsigned int gap_wl_data_source_req_offer[] = {
	0
};
static const bool sis_wl_data_source_evt_target[] = {
	true
};
static const unsigned int gap_wl_data_source_evt_target[] = {
	0
};
void do_wl_data_source_evt_send(struct context *ctx, const char *mime_type, int fd);
void call_wl_data_source_evt_send(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt) {
	unsigned int i = 0;
	unsigned int k = 0;
	const char *arg0 = (const char *)&payload[i + 1];
	if (!payload[i]) arg0 = NULL;
	int arg1 = fds[k];
	do_wl_data_source_evt_send(ctx, arg0, arg1);
	(void)mt;
}
static const bool sis_wl_data_source_evt_send[] = {
	true
};
static const unsigned int gap_wl_data_source_evt_send[] = {
	0
};
static const struct msg_data reqs_wl_data_source[] = {
	{"offer", 1, 1, gap_wl_data_source_req_offer, sis_wl_data_source_req_offer, 0, 0, NULL, NULL, false, NULL},
	{"destroy", 0, 0, NULL, NULL, 0, 0, NULL, NULL, true, NULL},
	{"set_actions", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
};
static const struct msg_data evts_wl_data_source[] = {
	{"target", 1, 1, gap_wl_data_source_evt_target, sis_wl_data_source_evt_target, 0, 0, NULL, NULL, false, NULL},
	{"send", 1, 1, gap_wl_data_source_evt_send, sis_wl_data_source_evt_send, 1, 0, NULL, NULL, false, call_wl_data_source_evt_send},
	{"cancelled", 0, 0, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"dnd_drop_performed", 0, 0, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"dnd_finished", 0, 0, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"action", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
};
const struct wp_interface intf_wl_data_source = {
	"wl_data_source",
	{reqs_wl_data_source, evts_wl_data_source},
	{3, 6},
};
static const unsigned int noi_wl_data_device_evt_data_offer[] = {
	0
};
static const struct wp_interface *not_wl_data_device_evt_data_offer[] = {
	&intf_wl_data_offer
};
static const struct msg_data reqs_wl_data_device[] = {
	{"start_drag", 0, 4, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"set_selection", 0, 2, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"release", 0, 0, NULL, NULL, 0, 0, NULL, NULL, true, NULL},
};
static const struct msg_data evts_wl_data_device[] = {
	{"data_offer", 0, 1, NULL, NULL, 0, 1, noi_wl_data_device_evt_data_offer, not_wl_data_device_evt_data_offer, false, NULL},
	{"enter", 0, 5, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"leave", 0, 0, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"motion", 0, 3, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"drop", 0, 0, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"selection", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
};
const struct wp_interface intf_wl_data_device = {
	"wl_data_device",
	{reqs_wl_data_device, evts_wl_data_device},
	{3, 6},
};
static const unsigned int noi_wl_data_device_manager_req_create_data_source[] = {
	0
};
static const struct wp_interface *not_wl_data_device_manager_req_create_data_source[] = {
	&intf_wl_data_source
};
static const unsigned int noi_wl_data_device_manager_req_get_data_device[] = {
	0
};
static const struct wp_interface *not_wl_data_device_manager_req_get_data_device[] = {
	&intf_wl_data_device
};
static const struct msg_data reqs_wl_data_device_manager[] = {
	{"create_data_source", 0, 1, NULL, NULL, 0, 1, noi_wl_data_device_manager_req_create_data_source, not_wl_data_device_manager_req_create_data_source, false, NULL},
	{"get_data_device", 0, 2, NULL, NULL, 0, 1, noi_wl_data_device_manager_req_get_data_device, not_wl_data_device_manager_req_get_data_device, false, NULL},
};
const struct wp_interface intf_wl_data_device_manager = {
	"wl_data_device_manager",
	{reqs_wl_data_device_manager, NULL},
	{2, 0},
};
static const unsigned int noi_wl_shell_req_get_shell_surface[] = {
	0
};
static const struct wp_interface *not_wl_shell_req_get_shell_surface[] = {
	&intf_wl_shell_surface
};
static const struct msg_data reqs_wl_shell[] = {
	{"get_shell_surface", 0, 2, NULL, NULL, 0, 1, noi_wl_shell_req_get_shell_surface, not_wl_shell_req_get_shell_surface, false, NULL},
};
const struct wp_interface intf_wl_shell = {
	"wl_shell",
	{reqs_wl_shell, NULL},
	{1, 0},
};
static const bool sis_wl_shell_surface_req_set_title[] = {
	true
};
static const unsigned int gap_wl_shell_surface_req_set_title[] = {
	0
};
static const bool sis_wl_shell_surface_req_set_class[] = {
	true
};
static const unsigned int gap_wl_shell_surface_req_set_class[] = {
	0
};
static const struct msg_data reqs_wl_shell_surface[] = {
	{"pong", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"move", 0, 2, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"resize", 0, 3, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"set_toplevel", 0, 0, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"set_transient", 0, 4, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"set_fullscreen", 0, 3, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"set_popup", 0, 6, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"set_maximized", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"set_title", 1, 1, gap_wl_shell_surface_req_set_title, sis_wl_shell_surface_req_set_title, 0, 0, NULL, NULL, false, NULL},
	{"set_class", 1, 1, gap_wl_shell_surface_req_set_class, sis_wl_shell_surface_req_set_class, 0, 0, NULL, NULL, false, NULL},
};
static const struct msg_data evts_wl_shell_surface[] = {
	{"ping", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"configure", 0, 3, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"popup_done", 0, 0, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
};
const struct wp_interface intf_wl_shell_surface = {
	"wl_shell_surface",
	{reqs_wl_shell_surface, evts_wl_shell_surface},
	{10, 3},
};
void do_wl_surface_req_attach(struct context *ctx, struct wp_object *buffer, int32_t x, int32_t y);
void call_wl_surface_req_attach(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt) {
	unsigned int i = 0;
	struct wp_object *arg0 = get_object(mt, payload[i++], &intf_wl_buffer);
	int32_t arg1 = (int32_t)payload[i++];
	int32_t arg2 = (int32_t)payload[i];
	do_wl_surface_req_attach(ctx, arg0, arg1, arg2);
	(void)fds;
}
void do_wl_surface_req_damage(struct context *ctx, int32_t x, int32_t y, int32_t width, int32_t height);
void call_wl_surface_req_damage(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt) {
	unsigned int i = 0;
	int32_t arg0 = (int32_t)payload[i++];
	int32_t arg1 = (int32_t)payload[i++];
	int32_t arg2 = (int32_t)payload[i++];
	int32_t arg3 = (int32_t)payload[i];
	do_wl_surface_req_damage(ctx, arg0, arg1, arg2, arg3);
	(void)mt;
	(void)fds;
}
static const unsigned int noi_wl_surface_req_frame[] = {
	0
};
static const struct wp_interface *not_wl_surface_req_frame[] = {
	&intf_wl_callback
};
void do_wl_surface_req_commit(struct context *ctx);
void call_wl_surface_req_commit(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt) {
	do_wl_surface_req_commit(ctx);
	(void)mt;
	(void)fds;
	(void)payload;
}
void do_wl_surface_req_set_buffer_transform(struct context *ctx, int32_t transform);
void call_wl_surface_req_set_buffer_transform(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt) {
	unsigned int i = 0;
	int32_t arg0 = (int32_t)payload[i];
	do_wl_surface_req_set_buffer_transform(ctx, arg0);
	(void)mt;
	(void)fds;
}
void do_wl_surface_req_set_buffer_scale(struct context *ctx, int32_t scale);
void call_wl_surface_req_set_buffer_scale(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt) {
	unsigned int i = 0;
	int32_t arg0 = (int32_t)payload[i];
	do_wl_surface_req_set_buffer_scale(ctx, arg0);
	(void)mt;
	(void)fds;
}
void do_wl_surface_req_damage_buffer(struct context *ctx, int32_t x, int32_t y, int32_t width, int32_t height);
void call_wl_surface_req_damage_buffer(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt) {
	unsigned int i = 0;
	int32_t arg0 = (int32_t)payload[i++];
	int32_t arg1 = (int32_t)payload[i++];
	int32_t arg2 = (int32_t)payload[i++];
	int32_t arg3 = (int32_t)payload[i];
	do_wl_surface_req_damage_buffer(ctx, arg0, arg1, arg2, arg3);
	(void)mt;
	(void)fds;
}
static const struct msg_data reqs_wl_surface[] = {
	{"destroy", 0, 0, NULL, NULL, 0, 0, NULL, NULL, true, NULL},
	{"attach", 0, 3, NULL, NULL, 0, 0, NULL, NULL, false, call_wl_surface_req_attach},
	{"damage", 0, 4, NULL, NULL, 0, 0, NULL, NULL, false, call_wl_surface_req_damage},
	{"frame", 0, 1, NULL, NULL, 0, 1, noi_wl_surface_req_frame, not_wl_surface_req_frame, false, NULL},
	{"set_opaque_region", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"set_input_region", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"commit", 0, 0, NULL, NULL, 0, 0, NULL, NULL, false, call_wl_surface_req_commit},
	{"set_buffer_transform", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, call_wl_surface_req_set_buffer_transform},
	{"set_buffer_scale", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, call_wl_surface_req_set_buffer_scale},
	{"damage_buffer", 0, 4, NULL, NULL, 0, 0, NULL, NULL, false, call_wl_surface_req_damage_buffer},
};
static const struct msg_data evts_wl_surface[] = {
	{"enter", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"leave", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
};
const struct wp_interface intf_wl_surface = {
	"wl_surface",
	{reqs_wl_surface, evts_wl_surface},
	{10, 2},
};
static const unsigned int noi_wl_seat_req_get_pointer[] = {
	0
};
static const struct wp_interface *not_wl_seat_req_get_pointer[] = {
	&intf_wl_pointer
};
static const unsigned int noi_wl_seat_req_get_keyboard[] = {
	0
};
static const struct wp_interface *not_wl_seat_req_get_keyboard[] = {
	&intf_wl_keyboard
};
static const unsigned int noi_wl_seat_req_get_touch[] = {
	0
};
static const struct wp_interface *not_wl_seat_req_get_touch[] = {
	&intf_wl_touch
};
static const bool sis_wl_seat_evt_name[] = {
	true
};
static const unsigned int gap_wl_seat_evt_name[] = {
	0
};
static const struct msg_data reqs_wl_seat[] = {
	{"get_pointer", 0, 1, NULL, NULL, 0, 1, noi_wl_seat_req_get_pointer, not_wl_seat_req_get_pointer, false, NULL},
	{"get_keyboard", 0, 1, NULL, NULL, 0, 1, noi_wl_seat_req_get_keyboard, not_wl_seat_req_get_keyboard, false, NULL},
	{"get_touch", 0, 1, NULL, NULL, 0, 1, noi_wl_seat_req_get_touch, not_wl_seat_req_get_touch, false, NULL},
	{"release", 0, 0, NULL, NULL, 0, 0, NULL, NULL, true, NULL},
};
static const struct msg_data evts_wl_seat[] = {
	{"capabilities", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"name", 1, 1, gap_wl_seat_evt_name, sis_wl_seat_evt_name, 0, 0, NULL, NULL, false, NULL},
};
const struct wp_interface intf_wl_seat = {
	"wl_seat",
	{reqs_wl_seat, evts_wl_seat},
	{4, 2},
};
static const struct msg_data reqs_wl_pointer[] = {
	{"set_cursor", 0, 4, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"release", 0, 0, NULL, NULL, 0, 0, NULL, NULL, true, NULL},
};
static const struct msg_data evts_wl_pointer[] = {
	{"enter", 0, 4, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"leave", 0, 2, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"motion", 0, 3, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"button", 0, 4, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"axis", 0, 3, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"frame", 0, 0, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"axis_source", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"axis_stop", 0, 2, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"axis_discrete", 0, 2, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
};
const struct wp_interface intf_wl_pointer = {
	"wl_pointer",
	{reqs_wl_pointer, evts_wl_pointer},
	{2, 9},
};
void do_wl_keyboard_evt_keymap(struct context *ctx, uint32_t format, int fd, uint32_t size);
void call_wl_keyboard_evt_keymap(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt) {
	unsigned int i = 0;
	unsigned int k = 0;
	uint32_t arg0 = payload[i++];
	int arg1 = fds[k];
	uint32_t arg2 = payload[i];
	do_wl_keyboard_evt_keymap(ctx, arg0, arg1, arg2);
	(void)mt;
}
static const bool sis_wl_keyboard_evt_enter[] = {
	false
};
static const unsigned int gap_wl_keyboard_evt_enter[] = {
	0
};
static const struct msg_data reqs_wl_keyboard[] = {
	{"release", 0, 0, NULL, NULL, 0, 0, NULL, NULL, true, NULL},
};
static const struct msg_data evts_wl_keyboard[] = {
	{"keymap", 0, 2, NULL, NULL, 1, 0, NULL, NULL, false, call_wl_keyboard_evt_keymap},
	{"enter", 1, 3, gap_wl_keyboard_evt_enter, sis_wl_keyboard_evt_enter, 0, 0, NULL, NULL, false, NULL},
	{"leave", 0, 2, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"key", 0, 4, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"modifiers", 0, 5, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"repeat_info", 0, 2, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
};
const struct wp_interface intf_wl_keyboard = {
	"wl_keyboard",
	{reqs_wl_keyboard, evts_wl_keyboard},
	{1, 6},
};
static const struct msg_data reqs_wl_touch[] = {
	{"release", 0, 0, NULL, NULL, 0, 0, NULL, NULL, true, NULL},
};
static const struct msg_data evts_wl_touch[] = {
	{"down", 0, 6, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"up", 0, 3, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"motion", 0, 4, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"frame", 0, 0, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"cancel", 0, 0, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"shape", 0, 3, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"orientation", 0, 2, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
};
const struct wp_interface intf_wl_touch = {
	"wl_touch",
	{reqs_wl_touch, evts_wl_touch},
	{1, 7},
};
static const bool sis_wl_output_evt_geometry[] = {
	true, true
};
static const unsigned int gap_wl_output_evt_geometry[] = {
	1, 1
};
static const struct msg_data reqs_wl_output[] = {
	{"release", 0, 0, NULL, NULL, 0, 0, NULL, NULL, true, NULL},
};
static const struct msg_data evts_wl_output[] = {
	{"geometry", 2, 6, gap_wl_output_evt_geometry, sis_wl_output_evt_geometry, 0, 0, NULL, NULL, false, NULL},
	{"mode", 0, 4, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"done", 0, 0, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"scale", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
};
const struct wp_interface intf_wl_output = {
	"wl_output",
	{reqs_wl_output, evts_wl_output},
	{1, 4},
};
static const struct msg_data reqs_wl_region[] = {
	{"destroy", 0, 0, NULL, NULL, 0, 0, NULL, NULL, true, NULL},
	{"add", 0, 4, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"subtract", 0, 4, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
};
const struct wp_interface intf_wl_region = {
	"wl_region",
	{reqs_wl_region, NULL},
	{3, 0},
};
static const unsigned int noi_wl_subcompositor_req_get_subsurface[] = {
	0
};
static const struct wp_interface *not_wl_subcompositor_req_get_subsurface[] = {
	&intf_wl_subsurface
};
static const struct msg_data reqs_wl_subcompositor[] = {
	{"destroy", 0, 0, NULL, NULL, 0, 0, NULL, NULL, true, NULL},
	{"get_subsurface", 0, 3, NULL, NULL, 0, 1, noi_wl_subcompositor_req_get_subsurface, not_wl_subcompositor_req_get_subsurface, false, NULL},
};
const struct wp_interface intf_wl_subcompositor = {
	"wl_subcompositor",
	{reqs_wl_subcompositor, NULL},
	{2, 0},
};
static const struct msg_data reqs_wl_subsurface[] = {
	{"destroy", 0, 0, NULL, NULL, 0, 0, NULL, NULL, true, NULL},
	{"set_position", 0, 2, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"place_above", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"place_below", 0, 1, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"set_sync", 0, 0, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
	{"set_desync", 0, 0, NULL, NULL, 0, 0, NULL, NULL, false, NULL},
};
const struct wp_interface intf_wl_subsurface = {
	"wl_subsurface",
	{reqs_wl_subsurface, NULL},
	{6, 0},
};
