#ifndef PROTOCOL_WAYLAND_H
#define PROTOCOL_WAYLAND_H

#include "symgen_types.h"
extern const struct wp_interface intf_wl_buffer;
extern const struct wp_interface intf_wl_callback;
extern const struct wp_interface intf_wl_compositor;
extern const struct wp_interface intf_wl_data_device;
extern const struct wp_interface intf_wl_data_device_manager;
extern const struct wp_interface intf_wl_data_offer;
extern const struct wp_interface intf_wl_data_source;
extern const struct wp_interface intf_wl_display;
extern const struct wp_interface intf_wl_keyboard;
extern const struct wp_interface intf_wl_output;
extern const struct wp_interface intf_wl_pointer;
extern const struct wp_interface intf_wl_region;
extern const struct wp_interface intf_wl_registry;
extern const struct wp_interface intf_wl_seat;
extern const struct wp_interface intf_wl_shell;
extern const struct wp_interface intf_wl_shell_surface;
extern const struct wp_interface intf_wl_shm;
extern const struct wp_interface intf_wl_shm_pool;
extern const struct wp_interface intf_wl_subcompositor;
extern const struct wp_interface intf_wl_subsurface;
extern const struct wp_interface intf_wl_surface;
extern const struct wp_interface intf_wl_touch;
void do_wl_display_req_sync(struct context *ctx, struct wp_object *callback);
void call_wl_display_req_sync(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
void do_wl_display_req_get_registry(struct context *ctx, struct wp_object *registry);
void call_wl_display_req_get_registry(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
void do_wl_display_evt_error(struct context *ctx, struct wp_object *object_id, uint32_t code, const char *message);
void call_wl_display_evt_error(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
#define WL_DISPLAY_ERROR_INVALID_OBJECT 0
#define WL_DISPLAY_ERROR_INVALID_METHOD 1
#define WL_DISPLAY_ERROR_NO_MEMORY 2
#define WL_DISPLAY_ERROR_IMPLEMENTATION 3
void do_wl_display_evt_delete_id(struct context *ctx, uint32_t id);
void call_wl_display_evt_delete_id(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
void do_wl_registry_req_bind(struct context *ctx, uint32_t name, const char *interface, uint32_t version, struct wp_object *id);
void call_wl_registry_req_bind(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
void do_wl_registry_evt_global(struct context *ctx, uint32_t name, const char *interface, uint32_t version);
void call_wl_registry_evt_global(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
void do_wl_registry_evt_global_remove(struct context *ctx, uint32_t name);
void call_wl_registry_evt_global_remove(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
void do_wl_shm_pool_req_create_buffer(struct context *ctx, struct wp_object *id, int32_t offset, int32_t width, int32_t height, int32_t stride, uint32_t format);
void call_wl_shm_pool_req_create_buffer(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
void do_wl_shm_pool_req_resize(struct context *ctx, int32_t size);
void call_wl_shm_pool_req_resize(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
#define WL_SHM_ERROR_INVALID_FORMAT 0
#define WL_SHM_ERROR_INVALID_STRIDE 1
#define WL_SHM_ERROR_INVALID_FD 2
#define WL_SHM_FORMAT_ARGB8888 0
#define WL_SHM_FORMAT_XRGB8888 1
#define WL_SHM_FORMAT_C8 0x20203843
#define WL_SHM_FORMAT_RGB332 0x38424752
#define WL_SHM_FORMAT_BGR233 0x38524742
#define WL_SHM_FORMAT_XRGB4444 0x32315258
#define WL_SHM_FORMAT_XBGR4444 0x32314258
#define WL_SHM_FORMAT_RGBX4444 0x32315852
#define WL_SHM_FORMAT_BGRX4444 0x32315842
#define WL_SHM_FORMAT_ARGB4444 0x32315241
#define WL_SHM_FORMAT_ABGR4444 0x32314241
#define WL_SHM_FORMAT_RGBA4444 0x32314152
#define WL_SHM_FORMAT_BGRA4444 0x32314142
#define WL_SHM_FORMAT_XRGB1555 0x35315258
#define WL_SHM_FORMAT_XBGR1555 0x35314258
#define WL_SHM_FORMAT_RGBX5551 0x35315852
#define WL_SHM_FORMAT_BGRX5551 0x35315842
#define WL_SHM_FORMAT_ARGB1555 0x35315241
#define WL_SHM_FORMAT_ABGR1555 0x35314241
#define WL_SHM_FORMAT_RGBA5551 0x35314152
#define WL_SHM_FORMAT_BGRA5551 0x35314142
#define WL_SHM_FORMAT_RGB565 0x36314752
#define WL_SHM_FORMAT_BGR565 0x36314742
#define WL_SHM_FORMAT_RGB888 0x34324752
#define WL_SHM_FORMAT_BGR888 0x34324742
#define WL_SHM_FORMAT_XBGR8888 0x34324258
#define WL_SHM_FORMAT_RGBX8888 0x34325852
#define WL_SHM_FORMAT_BGRX8888 0x34325842
#define WL_SHM_FORMAT_ABGR8888 0x34324241
#define WL_SHM_FORMAT_RGBA8888 0x34324152
#define WL_SHM_FORMAT_BGRA8888 0x34324142
#define WL_SHM_FORMAT_XRGB2101010 0x30335258
#define WL_SHM_FORMAT_XBGR2101010 0x30334258
#define WL_SHM_FORMAT_RGBX1010102 0x30335852
#define WL_SHM_FORMAT_BGRX1010102 0x30335842
#define WL_SHM_FORMAT_ARGB2101010 0x30335241
#define WL_SHM_FORMAT_ABGR2101010 0x30334241
#define WL_SHM_FORMAT_RGBA1010102 0x30334152
#define WL_SHM_FORMAT_BGRA1010102 0x30334142
#define WL_SHM_FORMAT_YUYV 0x56595559
#define WL_SHM_FORMAT_YVYU 0x55595659
#define WL_SHM_FORMAT_UYVY 0x59565955
#define WL_SHM_FORMAT_VYUY 0x59555956
#define WL_SHM_FORMAT_AYUV 0x56555941
#define WL_SHM_FORMAT_NV12 0x3231564e
#define WL_SHM_FORMAT_NV21 0x3132564e
#define WL_SHM_FORMAT_NV16 0x3631564e
#define WL_SHM_FORMAT_NV61 0x3136564e
#define WL_SHM_FORMAT_YUV410 0x39565559
#define WL_SHM_FORMAT_YVU410 0x39555659
#define WL_SHM_FORMAT_YUV411 0x31315559
#define WL_SHM_FORMAT_YVU411 0x31315659
#define WL_SHM_FORMAT_YUV420 0x32315559
#define WL_SHM_FORMAT_YVU420 0x32315659
#define WL_SHM_FORMAT_YUV422 0x36315559
#define WL_SHM_FORMAT_YVU422 0x36315659
#define WL_SHM_FORMAT_YUV444 0x34325559
#define WL_SHM_FORMAT_YVU444 0x34325659
#define WL_SHM_FORMAT_R8 0x20203852
#define WL_SHM_FORMAT_R16 0x20363152
#define WL_SHM_FORMAT_RG88 0x38384752
#define WL_SHM_FORMAT_GR88 0x38385247
#define WL_SHM_FORMAT_RG1616 0x32334752
#define WL_SHM_FORMAT_GR1616 0x32335247
#define WL_SHM_FORMAT_XRGB16161616F 0x48345258
#define WL_SHM_FORMAT_XBGR16161616F 0x48344258
#define WL_SHM_FORMAT_ARGB16161616F 0x48345241
#define WL_SHM_FORMAT_ABGR16161616F 0x48344241
#define WL_SHM_FORMAT_XYUV8888 0x56555958
#define WL_SHM_FORMAT_VUY888 0x34325556
#define WL_SHM_FORMAT_VUY101010 0x30335556
#define WL_SHM_FORMAT_Y210 0x30313259
#define WL_SHM_FORMAT_Y212 0x32313259
#define WL_SHM_FORMAT_Y216 0x36313259
#define WL_SHM_FORMAT_Y410 0x30313459
#define WL_SHM_FORMAT_Y412 0x32313459
#define WL_SHM_FORMAT_Y416 0x36313459
#define WL_SHM_FORMAT_XVYU2101010 0x30335658
#define WL_SHM_FORMAT_XVYU12_16161616 0x36335658
#define WL_SHM_FORMAT_XVYU16161616 0x38345658
#define WL_SHM_FORMAT_Y0L0 0x304c3059
#define WL_SHM_FORMAT_X0L0 0x304c3058
#define WL_SHM_FORMAT_Y0L2 0x324c3059
#define WL_SHM_FORMAT_X0L2 0x324c3058
#define WL_SHM_FORMAT_YUV420_8BIT 0x38305559
#define WL_SHM_FORMAT_YUV420_10BIT 0x30315559
#define WL_SHM_FORMAT_XRGB8888_A8 0x38415258
#define WL_SHM_FORMAT_XBGR8888_A8 0x38414258
#define WL_SHM_FORMAT_RGBX8888_A8 0x38415852
#define WL_SHM_FORMAT_BGRX8888_A8 0x38415842
#define WL_SHM_FORMAT_RGB888_A8 0x38413852
#define WL_SHM_FORMAT_BGR888_A8 0x38413842
#define WL_SHM_FORMAT_RGB565_A8 0x38413552
#define WL_SHM_FORMAT_BGR565_A8 0x38413542
#define WL_SHM_FORMAT_NV24 0x3432564e
#define WL_SHM_FORMAT_NV42 0x3234564e
#define WL_SHM_FORMAT_P210 0x30313250
#define WL_SHM_FORMAT_P010 0x30313050
#define WL_SHM_FORMAT_P012 0x32313050
#define WL_SHM_FORMAT_P016 0x36313050
void do_wl_shm_req_create_pool(struct context *ctx, struct wp_object *id, int fd, int32_t size);
void call_wl_shm_req_create_pool(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
void do_wl_buffer_evt_release(struct context *ctx);
void call_wl_buffer_evt_release(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
#define WL_DATA_OFFER_ERROR_INVALID_FINISH 0
#define WL_DATA_OFFER_ERROR_INVALID_ACTION_MASK 1
#define WL_DATA_OFFER_ERROR_INVALID_ACTION 2
#define WL_DATA_OFFER_ERROR_INVALID_OFFER 3
void do_wl_data_offer_req_receive(struct context *ctx, const char *mime_type, int fd);
void call_wl_data_offer_req_receive(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
#define WL_DATA_SOURCE_ERROR_INVALID_ACTION_MASK 0
#define WL_DATA_SOURCE_ERROR_INVALID_SOURCE 1
void do_wl_data_source_evt_send(struct context *ctx, const char *mime_type, int fd);
void call_wl_data_source_evt_send(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
#define WL_DATA_DEVICE_ERROR_ROLE 0
#define WL_DATA_DEVICE_MANAGER_DND_ACTION_NONE 0
#define WL_DATA_DEVICE_MANAGER_DND_ACTION_COPY 1
#define WL_DATA_DEVICE_MANAGER_DND_ACTION_MOVE 2
#define WL_DATA_DEVICE_MANAGER_DND_ACTION_ASK 4
#define WL_SHELL_ERROR_ROLE 0
#define WL_SHELL_SURFACE_RESIZE_NONE 0
#define WL_SHELL_SURFACE_RESIZE_TOP 1
#define WL_SHELL_SURFACE_RESIZE_BOTTOM 2
#define WL_SHELL_SURFACE_RESIZE_LEFT 4
#define WL_SHELL_SURFACE_RESIZE_TOP_LEFT 5
#define WL_SHELL_SURFACE_RESIZE_BOTTOM_LEFT 6
#define WL_SHELL_SURFACE_RESIZE_RIGHT 8
#define WL_SHELL_SURFACE_RESIZE_TOP_RIGHT 9
#define WL_SHELL_SURFACE_RESIZE_BOTTOM_RIGHT 10
#define WL_SHELL_SURFACE_TRANSIENT_INACTIVE 0x1
#define WL_SHELL_SURFACE_FULLSCREEN_METHOD_DEFAULT 0
#define WL_SHELL_SURFACE_FULLSCREEN_METHOD_SCALE 1
#define WL_SHELL_SURFACE_FULLSCREEN_METHOD_DRIVER 2
#define WL_SHELL_SURFACE_FULLSCREEN_METHOD_FILL 3
#define WL_SURFACE_ERROR_INVALID_SCALE 0
#define WL_SURFACE_ERROR_INVALID_TRANSFORM 1
#define WL_SURFACE_ERROR_INVALID_SIZE 2
void do_wl_surface_req_attach(struct context *ctx, struct wp_object *buffer, int32_t x, int32_t y);
void call_wl_surface_req_attach(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
void do_wl_surface_req_damage(struct context *ctx, int32_t x, int32_t y, int32_t width, int32_t height);
void call_wl_surface_req_damage(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
void do_wl_surface_req_commit(struct context *ctx);
void call_wl_surface_req_commit(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
void do_wl_surface_req_set_buffer_transform(struct context *ctx, int32_t transform);
void call_wl_surface_req_set_buffer_transform(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
void do_wl_surface_req_set_buffer_scale(struct context *ctx, int32_t scale);
void call_wl_surface_req_set_buffer_scale(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
void do_wl_surface_req_damage_buffer(struct context *ctx, int32_t x, int32_t y, int32_t width, int32_t height);
void call_wl_surface_req_damage_buffer(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
#define WL_SEAT_CAPABILITY_POINTER 1
#define WL_SEAT_CAPABILITY_KEYBOARD 2
#define WL_SEAT_CAPABILITY_TOUCH 4
#define WL_SEAT_ERROR_MISSING_CAPABILITY 0
#define WL_POINTER_ERROR_ROLE 0
#define WL_POINTER_BUTTON_STATE_RELEASED 0
#define WL_POINTER_BUTTON_STATE_PRESSED 1
#define WL_POINTER_AXIS_VERTICAL_SCROLL 0
#define WL_POINTER_AXIS_HORIZONTAL_SCROLL 1
#define WL_POINTER_AXIS_SOURCE_WHEEL 0
#define WL_POINTER_AXIS_SOURCE_FINGER 1
#define WL_POINTER_AXIS_SOURCE_CONTINUOUS 2
#define WL_POINTER_AXIS_SOURCE_WHEEL_TILT 3
#define WL_KEYBOARD_KEYMAP_FORMAT_NO_KEYMAP 0
#define WL_KEYBOARD_KEYMAP_FORMAT_XKB_V1 1
void do_wl_keyboard_evt_keymap(struct context *ctx, uint32_t format, int fd, uint32_t size);
void call_wl_keyboard_evt_keymap(struct context *ctx, const uint32_t *payload, const int *fds, struct message_tracker *mt);
#define WL_KEYBOARD_KEY_STATE_RELEASED 0
#define WL_KEYBOARD_KEY_STATE_PRESSED 1
#define WL_OUTPUT_SUBPIXEL_UNKNOWN 0
#define WL_OUTPUT_SUBPIXEL_NONE 1
#define WL_OUTPUT_SUBPIXEL_HORIZONTAL_RGB 2
#define WL_OUTPUT_SUBPIXEL_HORIZONTAL_BGR 3
#define WL_OUTPUT_SUBPIXEL_VERTICAL_RGB 4
#define WL_OUTPUT_SUBPIXEL_VERTICAL_BGR 5
#define WL_OUTPUT_TRANSFORM_NORMAL 0
#define WL_OUTPUT_TRANSFORM_90 1
#define WL_OUTPUT_TRANSFORM_180 2
#define WL_OUTPUT_TRANSFORM_270 3
#define WL_OUTPUT_TRANSFORM_FLIPPED 4
#define WL_OUTPUT_TRANSFORM_FLIPPED_90 5
#define WL_OUTPUT_TRANSFORM_FLIPPED_180 6
#define WL_OUTPUT_TRANSFORM_FLIPPED_270 7
#define WL_OUTPUT_MODE_CURRENT 0x1
#define WL_OUTPUT_MODE_PREFERRED 0x2
#define WL_SUBCOMPOSITOR_ERROR_BAD_SURFACE 0
#define WL_SUBSURFACE_ERROR_BAD_SURFACE 0

#endif /* PROTOCOL_WAYLAND_H */
