#ifndef PROTOCOL_XDG_SHELL_H
#define PROTOCOL_XDG_SHELL_H

#include "symgen_types.h"
extern const struct wp_interface intf_wl_output;
extern const struct wp_interface intf_wl_seat;
extern const struct wp_interface intf_wl_surface;
extern const struct wp_interface intf_xdg_popup;
extern const struct wp_interface intf_xdg_positioner;
extern const struct wp_interface intf_xdg_surface;
extern const struct wp_interface intf_xdg_toplevel;
extern const struct wp_interface intf_xdg_wm_base;
#define XDG_WM_BASE_ERROR_ROLE 0
#define XDG_WM_BASE_ERROR_DEFUNCT_SURFACES 1
#define XDG_WM_BASE_ERROR_NOT_THE_TOPMOST_POPUP 2
#define XDG_WM_BASE_ERROR_INVALID_POPUP_PARENT 3
#define XDG_WM_BASE_ERROR_INVALID_SURFACE_STATE 4
#define XDG_WM_BASE_ERROR_INVALID_POSITIONER 5
#define XDG_POSITIONER_ERROR_INVALID_INPUT 0
#define XDG_POSITIONER_ANCHOR_NONE 0
#define XDG_POSITIONER_ANCHOR_TOP 1
#define XDG_POSITIONER_ANCHOR_BOTTOM 2
#define XDG_POSITIONER_ANCHOR_LEFT 3
#define XDG_POSITIONER_ANCHOR_RIGHT 4
#define XDG_POSITIONER_ANCHOR_TOP_LEFT 5
#define XDG_POSITIONER_ANCHOR_BOTTOM_LEFT 6
#define XDG_POSITIONER_ANCHOR_TOP_RIGHT 7
#define XDG_POSITIONER_ANCHOR_BOTTOM_RIGHT 8
#define XDG_POSITIONER_GRAVITY_NONE 0
#define XDG_POSITIONER_GRAVITY_TOP 1
#define XDG_POSITIONER_GRAVITY_BOTTOM 2
#define XDG_POSITIONER_GRAVITY_LEFT 3
#define XDG_POSITIONER_GRAVITY_RIGHT 4
#define XDG_POSITIONER_GRAVITY_TOP_LEFT 5
#define XDG_POSITIONER_GRAVITY_BOTTOM_LEFT 6
#define XDG_POSITIONER_GRAVITY_TOP_RIGHT 7
#define XDG_POSITIONER_GRAVITY_BOTTOM_RIGHT 8
#define XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_NONE 0
#define XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_SLIDE_X 1
#define XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_SLIDE_Y 2
#define XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_FLIP_X 4
#define XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_FLIP_Y 8
#define XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_RESIZE_X 16
#define XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_RESIZE_Y 32
#define XDG_SURFACE_ERROR_NOT_CONSTRUCTED 1
#define XDG_SURFACE_ERROR_ALREADY_CONSTRUCTED 2
#define XDG_SURFACE_ERROR_UNCONFIGURED_BUFFER 3
#define XDG_TOPLEVEL_RESIZE_EDGE_NONE 0
#define XDG_TOPLEVEL_RESIZE_EDGE_TOP 1
#define XDG_TOPLEVEL_RESIZE_EDGE_BOTTOM 2
#define XDG_TOPLEVEL_RESIZE_EDGE_LEFT 4
#define XDG_TOPLEVEL_RESIZE_EDGE_TOP_LEFT 5
#define XDG_TOPLEVEL_RESIZE_EDGE_BOTTOM_LEFT 6
#define XDG_TOPLEVEL_RESIZE_EDGE_RIGHT 8
#define XDG_TOPLEVEL_RESIZE_EDGE_TOP_RIGHT 9
#define XDG_TOPLEVEL_RESIZE_EDGE_BOTTOM_RIGHT 10
#define XDG_TOPLEVEL_STATE_MAXIMIZED 1
#define XDG_TOPLEVEL_STATE_FULLSCREEN 2
#define XDG_TOPLEVEL_STATE_RESIZING 3
#define XDG_TOPLEVEL_STATE_ACTIVATED 4
#define XDG_TOPLEVEL_STATE_TILED_LEFT 5
#define XDG_TOPLEVEL_STATE_TILED_RIGHT 6
#define XDG_TOPLEVEL_STATE_TILED_TOP 7
#define XDG_TOPLEVEL_STATE_TILED_BOTTOM 8
#define XDG_POPUP_ERROR_INVALID_GRAB 0

#endif /* PROTOCOL_XDG_SHELL_H */
